import numpy as np
from sklearn.preprocessing import StandardScaler
from sklearn.model_selection import train_test_split
from sklearn.svm import SVC

D = np.loadtxt( "datos.txt" )
print( D.shape )

X = D[:,0:2]
y = D[:,2]

print( X.shape )

# Como usaremos una máquina de vectores de soporte
# reescalamos los datos a media 0 y varianza igual a 1
reescalar = StandardScaler( )
reescalar.fit( X )
X2 = reescalar.transform( X )
print( X2.shape )

# Separamos los datos en datos de entrenamiento
# y datos de prueba
#

X_entrena, X_prueba, y_entrena, y_prueba = train_test_split( X2, y, random_state=2 )


clasificador = SVC( gamma=1 )
clasificador.fit( X_entrena, y_entrena )

exac_entrena = clasificador.score( X_entrena, y_entrena )
print( exac_entrena )

exac_prueba = clasificador.score( X_prueba, y_prueba )
print( exac_prueba )

print( clasificador.classes_ )
print( clasificador.dual_coef_ )
print( clasificador.intercept_ )
print( clasificador.support_vectors_ )
print( clasificador.support_ )
print( len(clasificador.support_) )
