import numpy as np
from sklearn.preprocessing import StandardScaler
from sklearn.model_selection import train_test_split
import matplotlib.pyplot as plt

# La función de decisión para la MVS lineal es
# f(x) = x^T c + b
# 
vc = np.array( [-1.40790914,  0.11547103] )
b  = 0.10231375

def funcion_decision( vx ) :
	c = vx[0]*vc[0] + vx[1]*vc[1] + b
	if c >= 0 :
		return 1
	else :
		return 0 

D = np.loadtxt( "datos.txt" )
print( D.shape )

X = D[:,0:2]
y = D[:,2]

print( X.shape )

# Como usaremos una máquina de vectores de soporte
# reescalamos los datos a media 0 y varianza igual a 1
reescalar = StandardScaler( )
reescalar.fit( X )
X2 = reescalar.transform( X )
print( X2.shape )

# Separamos los datos en datos de entrenamiento
# y datos de prueba
#

X_entrena, X_prueba, y_entrena, y_prueba = train_test_split( X2, y, random_state=2 )

# Hacemos la con la función de decisión
n, m = X_prueba.shape

i=0
while i<n :
	v = funcion_decision( X_prueba[i] )
	print( i, y_prueba[i], v )
	i += 1


fig, [ax1, ax2] = plt.subplots( nrows=1, ncols=2 )

ax1.scatter( X_entrena[:,0], X_entrena[:,1], c=y_entrena )
ax1.set_xlim( -2, 1.5 )
ax1.set_ylim( -3, 3.5 )

ax2.scatter( X_prueba[:,0], X_prueba[:,1], c=y_prueba )
ax2.set_xlim( -2, 1.5 )
ax2.set_ylim( -3, 3.5 )

# La función de decisión
# f(p) = [cx cy][x] + b
#               [y]
# f(p) =  cx x + cy y + b = 0
#  y = (- cx x - b )/cy

vx = np.linspace( -2, 1.5, 20 )
vy = (-vc[0]*vx - b )/vc[1]

ax1.plot( vx, vy )
ax2.plot( vx, vy )

plt.show( )
